%-----------------------------------------------------
%Set up the data sets
S=[0.05 .1 .2 .5 1 2]';
N=100;

OP = [3 1 16 1;
      3 3 16 1;
      4 1 16 1;
      4 2 16 1;
      4 4 16 1;
      5 1 16 1;
      5 2 16 1;
      5 3 16 1]';
OPm = [5 4 3 2 1];


load tst1;
X1 = [90.5 108.5]';
img1a = imrotate(img1,30,'bilinear');
img1b = imresize(img1,1.1,'bilinear');
img1c = imresize(img1a,1.1,'bilinear');

load tst2;
X2 = [451 632]';
tmp2a = uint8(mexMIx(img2,X2,[41 41]));
tmp2b = uint8(mexMIx(img2,X2,[81 81]));
tmp2c = uint8(mexMIx(img2,X2,[161 161]));

load tst3;
X3 = [80 92]';
tmp3a = uint8(mexMIx(img3,X3,[ 9  9]));
tmp3b = uint8(mexMIx(img3,X3,[17 17]));
tmp3c = uint8(mexMIx(img3,X3,[29 29]));

load tst4;
X4 = [992 920]';
k4 = fspecial('gaussian',8,2);

img4a = conv2(double(img4),k4,'same');
tmp4a = mexMIx(img4a,X4,[161 161]);
tmp4b = mexMIx(img4a,X4+1,[161 161]);

tmp4a = uint8(tmp4a(1:4:end,1:4:end));
tmp4b = uint8(tmp4b(1:4:end,1:4:end));
img4b = uint8(img4a(1:4:end,1:4:end));

X4 = X4/4;

tstSuite.img{1}  = img1;  tstSuite.tmp{1}  = tmp1; 
tstSuite.img{2}  = img1a; tstSuite.tmp{2}  = tmp1; 
tstSuite.img{3}  = img1b; tstSuite.tmp{3}  = tmp1; 
tstSuite.img{4}  = img1c; tstSuite.tmp{4}  = tmp1;
tstSuite.img{5}  = img2;  tstSuite.tmp{5}  = tmp2a;
tstSuite.img{6}  = img2;  tstSuite.tmp{6}  = tmp2b;
tstSuite.img{7}  = img2;  tstSuite.tmp{7}  = tmp2c;
tstSuite.img{8}  = img3;  tstSuite.tmp{8}  = tmp3a;
tstSuite.img{9}  = img3;  tstSuite.tmp{9}  = tmp3b;
tstSuite.img{10} = img3;  tstSuite.tmp{10} = tmp3c;
tstSuite.img{11} = img4a; tstSuite.tmp{11} = tmp4a;
tstSuite.img{12} = img4a; tstSuite.tmp{12} = tmp4b;

tstSuite.X{1} =  [X1' ]'; 
tstSuite.X{2} =  [X1' pi/6]'; 
tstSuite.X{3} =  [X1' 0 .1]'; 
tstSuite.X{4} =  [X1' pi/6 .1]'; 
tstSuite.X{5} =  [0 0 0 0 X2' ]'; 
tstSuite.X{6} =  [0 0 0 0 X2' ]'; 
tstSuite.X{7} =  [0 0 0 0 X2' ]'; 
tstSuite.X{8} =  [0 0 0 0 X3' ]'; 
tstSuite.X{9} =  [0 0 0 0 X3' ]'; 
tstSuite.X{10} = [0 0 0 0 X3' ]'; 
tstSuite.X{11} = [X4a' ]';
tstSuite.X{12} = [X4b' ]';

tstSuite.S{1}  = 181;
tstSuite.S{2}  = 181;
tstSuite.S{3}  = 181;
tstSuite.S{4}  = 181;
tstSuite.S{5}  = 41; 
tstSuite.S{6}  = 81; 
tstSuite.S{7}  = 161;
tstSuite.S{8}  =  9; 
tstSuite.S{9}  = 17; 
tstSuite.S{10} = 29; 
tstSuite.S{11} = 17; 
tstSuite.S{12} = 17; 

tstSuite.Scl=[0.05 .1 .2 .5 1 2]';
tstSuite.N=50;
tstSuite.OP = [1  1 16 1;
               3  1 16 1;
               41 1 16 1;
               42 1 16 1;
               43 1 16 1;
               51 1 16 1;
               52 1 16 1;
               53t 1 16 1]';
tstSuite.OPm = [5 4 3 2 1];

%-----------------------------------------------------
load tstSuite;
addpath ~/zPers/dev/zuseful/
n.Tst = length(tstSuite.X);
n.OPm = size(tstSuite.OPm,2);
n.OP = size(tstSuite.OP,2);
n.S = size(tstSuite.Scl,1);
n.N = 50;

[a.a a.b a.c] = ndgrid([5],[1:n.OP],[1:n.S]);
All = [a.a(:) a.b(:) a.c(:)];

clear tE tT;
for cDataSet = [8:10]
for cAll = [1:size(All,1)]
  cOPm = All(cAll,1); cOP = All(cAll,2); cS = All(cAll,3);

  tTmp = tstSuite.tmp{cDataSet};
  tImg = tstSuite.img{cDataSet};
  tX = tstSuite.X{cDataSet};
  
  %tS = tstSuite.S{cTst} * tstSuite.Scl(cS);
  tScl = tstSuite.Scl(cS);
  tOP = tstSuite.OP(:,cOP);
  tOPm = cOPm;%tstSuite.OPm(:,cOPm);
  
  tic; 
    tE{cDataSet,cAll}=tstCnvrg(tTmp,tImg,n.N,tX,tScl,[tOP;tOPm]); 
  tT(cDataSet,cAll)=toc;
  disp([cDataSet tOPm tOP' tScl tT(cDataSet,cAll)/1000])
end
end

save tstResults tE tT;

%-----------------------------------------------------
%Plot the results

for ci = 8:10 for cj = 1:54 tEmn(ci,cj) = mean(sum((tE{ci,cj}(5:6,:).^2)));	end;end

tEmn = reshape(tEmn,[10 9 6]);

%----------------------------
%Run the tests
matlab -nojvm -r "r1 = eccvTstCvg(1); save r1 r1; quit;"
matlab -nojvm -r "r2 = eccvTstCvg(2); save r2 r2; quit;"
matlab -nojvm -r "r3 = eccvTstCvg(3); save r3 r3; quit;"
matlab -nojvm -r "r4 = eccvTstCvg(4); save r4 r4; quit;"
matlab -nojvm -r "r5 = eccvTstCvg(5); save r5 r5; quit;"
matlab -nojvm -r "r6 = eccvTstCvg(6); save r6 r6; quit;"
matlab -nojvm -r "r7 = eccvTstCvg(7); save r7 r7; quit;"
matlab -nojvm -r "r8 = eccvTstCvg(8); save r8 r8; quit;"

%-------------------------------
%Collate thge results of the test
load r1 r2 r3 r4 r5 r6 r7;
load suite;

[hst1 hstX1 mn1 st1 n1] = errHst(suite.X0{1},r1.Y,1,2,100,1); %11
[hst2 hstX2 mn2 st2 n2] = errHst(suite.X0{2},r2.Y,1,2,100,1); %132
[hst3 hstX3 mn3 st3 n3] = errHst(suite.X0{3},r3.Y,5,6,100,1); %41
[hst4 hstX4 mn4 st4 n4] = errHst(suite.X0{4},r4.Y,1,2,100,1); %41
[hst5 hstX5 mn5 st5 n5] = errHst(suite.X0{5},r5.Y,1,2,100,1); %17
[hst5 hstX6 mn6 st6 n6] = errHst(suite.X0{6},r6.Y,1,2,100,1); %17
[hst7 hstX7 mn7 st7 n7] = errHst(suite.X0{7},r7.Y,1,2,100,1); %33

mn2=[0,mn2]; st2=[0,st2]; n2=[0,n2];
mn2(1)=mn2(2); st2(1)=st2(2); n2(1)=n2(2);
mn2(2)=0; st2(2)=0; n2(2)=0;

O =[mn1(:)' 
st1(:)' 
n1(:)'
mn2(:)' 
st2(:)' 
n2(:)'
mn3(:)' 
st3(:)' 
n3(:)'
mn4(:)' 
st4(:)' 
n4(:)'
mn5(:)' 
st5(:)' 
n5(:)'
mn6(:)' 
st6(:)' 
n6(:)'
mn7(:)' 
st7(:)' 
n7(:)'];

O=real(O);
O(3:3:end) = O(3:3:end)/1000;

%-------------------------------
%Plot the results of tests
load u2; load u3; load u4; load u0; load u6; load u7; load u8; load u9;
load suite;

%hst1 hstX1 mn1 st1 n1] = errHst(suite.X0{1},u1.Y,1,2,100,1); %11
%hst5 hstX5 mn5 st5 n5] = errHst(suite.X0{5},u5.Y,1,2,100,1); %17

[hst2 hstX2 mn2 st2 n2] = errHst(suite.X0{11},u2.Y,1,2,100,1); %Brain
[hst3 hstX3 mn3 st3 n3] = errHst(suite.X0{3},u3.Y,5,6,100,1); %Satellite
[hst4 hstX4 mn4 st4 n4] = errHst(suite.X0{4},u4.Y,1,2,100,1); %Hyena
[hst0 hstX0 mn0 st0 n0] = errHst(suite.X0{10},u0.Y,1,2,100,1); %Walk
[hst6 hstX6 mn6 st6 n6] = errHst(suite.X0{6},u6.Y,1,2,100,1); %Rhino
[hst7 hstX7 mn7 st7 n7] = errHst(suite.X0{7},u7.Y,1,2,100,1); %Hand
[hst8 hstX8 mn8 st8 n8] = errHst(suite.X0{8},u8.Y,1,2,100,1); %Claire
[hst9 hstX9 mn9 st9 n9] = errHst(suite.X0{9},u9.Y,1,2,100,1); %Sign


mn2=[0,mn2]; st2=[0,st2]; n2=[0,n2];

O =[mn2(:) st2(:) n2(:) mn3(:) st3(:) n3(:) mn4(:) st4(:) n4(:) ...
    mn0(:) st0(:) n0(:) mn6(:) st6(:) n6(:) mn7(:) st7(:) n7(:) ...
    mn8(:) st8(:) n8(:) mn9(:) st9(:) n9(:) ]';

O=real(O);
O(3:3:end,:) = O(3:3:end,:)/1000;

n=[11 3 4 10 6 7 8 9];
names={'i1';'i2';'i3';'i4';'i5';'i6';'i7';'i8'};
for l=1:8
  t = n(l);
  h = figure(1);
  set(h,'Position',[10 10 400 300]);
  colormap(repmat([0:255]'/255,1,3));
  axes('Position',[0 0 1 1]);
  image(suite.img{t});
  print('-djpeg98',[names{l} '.jpg']);
end

names={'t1';'t2';'t3';'t4';'t5';'t6';'t7';'t8'};
for l=1:8
  t = n(l);
  h = figure(1);
  set(h,'Position',[10 10 100 75]);
  colormap(repmat([0:255]'/255,1,3));
  axes('Position',[0 0 1 1]);
  image(suite.tmp{t});
  print('-djpeg98',[names{l} '.jpg']);
end

