%function [Y,V,Xmn] = msrGrid(tmp,img,iX,P,iXv)
%
%Constructs a grid of points around iX based on iXv and measures the values
%similarity values for them
function [Y,V,Xmn] = msrGrid(tmp,img,iX,P,iXv)
  
  wType = size(iX,1);
  
  for ci = 1:wType
    V{ci} = iX(ci)+[-iXv(ci,1):iXv(ci,2):iXv(ci,1)];
    N(ci) = size(V{ci},2);
  end
  
  if wType == 2
    [x,y] = ndgrid( V{1}, V{2} );
    oX1 = [x(:) y(:)]';
  elseif wType == 3
    [x,y,t] = ndgrid( V{1}, V{2}, V{3} );
    oX1 = [x(:) y(:) t(:)]';
  elseif wType == 4
    [x,y,t,s] = ndgrid( V{1}, V{2}, V{3}, V{4} );
    oX1 = [x(:) y(:) t(:) s(:)]';
  elseif wType == 6
    [x,y,t,s,a,b] = ndgrid( V{1}, V{2}, V{3}, V{4}, V{5}, V{6} );
    oX1 = [x(:) y(:) t(:) s(:) a(:) b(:)]';
  end
  
  Y = mexMImsr(tmp,img,oX1,P);
  [Ymn Yi] = min(Y);
  Y = reshape(Y,N);
  Xmn = [oX1(:,Yi); Ymn];
  
  
  
  